
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity REG_4 is
port (
  D   : in STD_LOGIC_VECTOR(3 downto 0);         
  Q   : out STD_LOGIC_VECTOR(3 downto 0);
  CLK : in STD_LOGIC;  
  CLR : in STD_LOGIC;
  CE  : in STD_LOGIC);
end REG_4;

architecture REG_4_ARCH of REG_4 is
begin

  process (CLK, CLR)
  begin
    if CLR = '1' 
    then
      Q <= (others => '0'); 
    elsif CLK='1' and CLK'event
    then
      if CE = '1' 
      then
        Q <= D; 
      end if;
    end if;
  end process;
  
end REG_4_ARCH;